// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.17.2
// source: product_category.sql

package db

import (
	"context"

	"github.com/google/uuid"
)

const createProductCategory = `-- name: CreateProductCategory :one
INSERT INTO product_categories (
  merchant_id,
  name
) VALUES (
  $1, $2
)
RETURNING id, merchant_id, index_id, name
`

type CreateProductCategoryParams struct {
	MerchantID uuid.UUID `json:"merchant_id"`
	Name       string    `json:"name"`
}

func (q *Queries) CreateProductCategory(ctx context.Context, arg CreateProductCategoryParams) (ProductCategory, error) {
	row := q.db.QueryRowContext(ctx, createProductCategory, arg.MerchantID, arg.Name)
	var i ProductCategory
	err := row.Scan(
		&i.ID,
		&i.MerchantID,
		&i.IndexID,
		&i.Name,
	)
	return i, err
}

const deleteProductCategory = `-- name: DeleteProductCategory :exec
DELETE FROM product_categories WHERE id = $1
`

func (q *Queries) DeleteProductCategory(ctx context.Context, id uuid.UUID) error {
	_, err := q.db.ExecContext(ctx, deleteProductCategory, id)
	return err
}

const listProductCategoriesByMerchantID = `-- name: ListProductCategoriesByMerchantID :many
SELECT id, merchant_id, index_id, name FROM product_categories
WHERE merchant_id = $1 
ORDER BY index_id
LIMIT $2
OFFSET $3
`

type ListProductCategoriesByMerchantIDParams struct {
	MerchantID uuid.UUID `json:"merchant_id"`
	Limit      int32     `json:"limit"`
	Offset     int32     `json:"offset"`
}

func (q *Queries) ListProductCategoriesByMerchantID(ctx context.Context, arg ListProductCategoriesByMerchantIDParams) ([]ProductCategory, error) {
	rows, err := q.db.QueryContext(ctx, listProductCategoriesByMerchantID, arg.MerchantID, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []ProductCategory{}
	for rows.Next() {
		var i ProductCategory
		if err := rows.Scan(
			&i.ID,
			&i.MerchantID,
			&i.IndexID,
			&i.Name,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updateProductCategory = `-- name: UpdateProductCategory :one
UPDATE product_categories   
SET name = $1
WHERE id = $2
RETURNING id, merchant_id, index_id, name
`

type UpdateProductCategoryParams struct {
	Name string    `json:"name"`
	ID   uuid.UUID `json:"id"`
}

func (q *Queries) UpdateProductCategory(ctx context.Context, arg UpdateProductCategoryParams) (ProductCategory, error) {
	row := q.db.QueryRowContext(ctx, updateProductCategory, arg.Name, arg.ID)
	var i ProductCategory
	err := row.Scan(
		&i.ID,
		&i.MerchantID,
		&i.IndexID,
		&i.Name,
	)
	return i, err
}
